---
title: RTCIceCandidate.protocol
slug: Web/API/RTCIceCandidate/protocol
tags:
  - API
  - ICE
  - Property
  - Protocol
  - RTCIceCandidate
  - Read-only
  - Reference
  - SDP
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("RTCIceCandidate")}}</strong> interface's read-only <strong><code>protocol</code></strong> property is a string which indicates whether the candidate uses {{Glossary("UDP")}} or {{Glossary("TCP")}} as its transport protocol.</span> <code>protocol</code> is <code>null</code> by default if not specified properly in the SDP, but this is an error condition and will result in a thrown exception when you call {{domxref("RTCPeerConnection.addIceCandidate()")}}.</p>

<p>The <code>protocol</code> property's value is set when the {{domxref("RTCIceCandidate.RTCIceCandidate", "RTCIceCandidate()")}} constructor is used. The value is automatically extracted from the {{domxref("RTCIceCandidateInit.candidate", "candidate")}} a-line, if it's formatted properly.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>protocol</em> = <em>RTCIceCandidate</em>.protocol;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which indicates what network protocol the candidate uses, UDP or TCP. These values are defined by the enumerated type {{domxref("RTCIceProtocol")}}:</p>

<p>{{page("/en-US/docs/Web/API/RTCIceProtocol", "Values")}}</p>

<div class="note">
<p><strong>Note:</strong> If <code>protocol</code> is <code>null</code> — and <code>protocol</code> is supported by the {{Glossary("user agent")}} — passing the candidate to {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} will fail, throwing an <code>OperationError</code> exception.</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<p>Here's an example candidate a-line from an ICE transaction:</p>

<pre>a=candidate:4234997325 1 udp 2043278322 192.168.0.56 44323 typ host</pre>

<p>The third field, <code>"udp"</code>, is the protocol type, indicating that the candidate would use the UDP transport protocol.</p>

<h2 id="Example">Example</h2>

<p>This code snippet examines the value of <code>protocol</code> to decide if it should look at the value of {{domxref("RTCIceCandidate.tcpType", "tcpType")}} to see if it's a <strong>simultaneous-open</strong> (<strong>S-O</strong>) candidate.</p>

<pre class="brush: js">if (candidate.protocol == "tcp") {
  if (candidate.tcpType == "so") {
    adjustForSimultaneousOpen(candidate);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicecandidate-protocol', 'RTCIceCandidate.protocol')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate.protocol")}}</p>
</div>
